#
# Triangle.pm -- Op`NXiIuWFNg𐶐jiaj
#
# sample file name: Triangle.pm.025

package Triangle;
use Carp qw(croak);
use Storable;
use Calendar;
use base Figure;

my $file = "Triangle";    # eLXgȂȂgq txt .Ă݂

use overload
  '""' => "toString",
  '0+' => "toNumber",
  '+'  => "add",
  '-'  => "subtract",
  '*'  => "multiply",
  '/'  => "divide",
  'nomethod'  => "nomethod",
;

my $subSpace = sub {
    my ($a, $b, $c) = @_;
    my $s = ($a + $b + $c) / 2;
    my $inRoot = $s * ($s - $a) * ($s - $b) * ($s - $c);
    if ($inRoot >= 0) {
        return sqrt($inRoot);
    } else {
        croak "you cannot construct the triangle with the sides $a, $b, $c !";
    }
};

sub new {
    my ($class, $a, $b, $c) = @_;
    unless ($a and $b and $c) {
        bless retrieve($file); # g[uê܂܃uX
    } else {
        bless { a => $a, b => $b, c => $c, s => $subSpace->($a, $b, $c),
        dob => Calendar->today->convert_to_Gregorian}, $class;
    }
}

sub DESTROY {
    store(shift, $file);    # C{Jĝ܂܃XgA
}

sub space {
    my $self = shift;
    warn "You are about to calculate the space of ", ref($self),  "!!! \n";
    return $self->{s};
}

sub sides {
    my $self = shift;
    unless (@_) {
        return ($self->{a}, $self->{b}, $self->{c});
    } else {
        my ($a, $b, $c) = @_;
        $self->{a} = $a;
        $self->{b} = $b;
        $self->{c} = $c;
        $self->{s} = $subSpace->($a, $b, $c);
    }
}



sub toString {
    my $self = shift;
    my $a = $self->{a};
    my $b = $self->{b};
    my $c = $self->{c};
    my $dob = $self->{dob};
    return ("($a, $b, $c) born in $dob");
}

sub toNumber {
    my $self = shift;
    return $self->{s};
}

sub add {
    my ($self, $b) = @_;
    $a = sprintf "%g", $self;
    ref $b and  $b = sprintf "%g", $b;
    return $a + $b;
}

sub subtract {
    my ($self, $b, $swap) = @_;
    $a = sprintf "%g", $self;
    ref $b and  $b = sprintf "%g", $b;
    unless ($swap) {
        return $a - $b;
    } else {
        return $b - $a;
    }
}

sub multiply {
    my ($self, $x) = @_;
    (ref $x or $x =~ /[^\.0-9]/) and croak "$x must be numeric value !";
    my $a = $self->{a} * $x;
    my $b = $self->{b} * $x;
    my $c = $self->{c} * $x;
    bless { a => $a, b => $b, c => $c, s => $subSpace->($a, $b, $c) };
}

sub divide {
    my ($self, $x, $swap) = @_;
    (ref $x or $x =~ /[^\.0-9]/) and croak "$x must be numeric value !";
    $swap and croak "$x / $self cannot be calculated !";
    my $a = $self->{a} / $x;
    my $b = $self->{b} / $x;
    my $c = $self->{c} / $x;
    bless { a => $a, b => $b, c => $c, s => $subSpace->($a, $b, $c) };
}

sub nomethod {
    my ($self, $x, $swap, $nomethod) = @_;
    croak "no such method: $nomethod : operand = $self, $x : swap = $swap";
}

1;
<to 2>
