#! /bin/perl
#
# benchmark.pl -- Op`̖ʐς߂@̔r
#
# sample file name: benchmark.pl

use strict;
use Benchmark qw(:all);

my $times = shift;

my $result = timethese ($times, {
  plain      => '&plain',
  subroutine => '&subroutine',
  module     => '&module',
  class      => '&class',
  object     => '&object',
});

cmpthese($result);

sub plain {
  my $a = 3;
  my $b = 4;
  my $c = 5;
  my $s = ($a + $b + $c) / 2;
  my $space = sqrt($s * ($s - $a) * ($s - $b) * ($s - $c));
}

sub subroutine {
  my $a = 3;
  my $b = 4;
  my $c = 5;
  my $space = &space($a, $b, $c);
}

sub space {
  my ($a, $b, $c) = @_;
  my $s = ($a + $b + $c) / 2;
  my $space = sqrt($s * ($s - $a) * ($s - $b) * ($s - $c));
  return $space;
}

sub module {
  use TriangleModule;
  my $a = 3;
  my $b = 4;
  my $c = 5;
  my $space = &TriangleModule::space($a, $b, $c);
}

sub class {
  use TriangleClass;
  my $a = 3;
  my $b = 4;
  my $c = 5;
  my $space = TriangleClass->space($a, $b, $c);
}

sub object {
  use TriangleObject;
  my $tri  = TriangleObject->new(3, 4, 5);
    # 3 ӂ̒ 3A4A5 ̎Op`
  my $space = $tri->space;
}
