#! /usr/bin/perl
#
# guestBook.cgi -- ゲストブック

use strict;
use warnings;
use CGI qw/:standard/;
use CGI::Carp qw/fatalsToBrowser warningsToBrowser/;

my ($data, @guest_words);
my $file = "guest_words.txt";
if (-f $file) {
	open IN, "<", $file or die "cannot open $file as IN because $!";
	@guest_words = <IN>;
	close IN;
} else {
	open OUT, ">", $file or die "cannot open $file as OUT because $!";
	@guest_words = ("今日までいただいたお言葉：\n");
	print OUT @guest_words;
	close OUT;
}

print header( -charset => "UTF-8" ),
	start_html("ようこそ！"),
	start_form(),
	"何か書いてください：", textfield(-name=>"data", -default=>"", -override=>1),
	hr();

if (param("data")) {
	my $str = localtime(time);
	push @guest_words, "【$str】".param("data")."\n";
}

for (@guest_words) {
	print $_, br();
}

print br(),
	submit("実行"),
	endform(),
	end_html();

open OUT, ">", $file or die "cannot open $file as OUT because $!";
print OUT @guest_words;
close OUT;
